var TableEditable = function () {

    var handleTable = function () {

        var hosturl = $("#hosturl").val();
        var getdata = function () {
            //happened in load the plugins
            //load all datalist
            var searchtxt = '';
            //name
            var listidn = 'namemedcine';
            $.post(hosturl + "/patienttreatmentajax/getthisserach", {listid: listidn, searchtxt: searchtxt}, function (data) {
                $('#' + listidn).html(data);
                //cat
                var listidc = 'groupmedcine';
                $.post(hosturl + "/patienttreatmentajax/getthisserach", {listid: listidc, searchtxt: searchtxt}, function (data) {
                    $('#' + listidc).html(data);
                    //dos
                    var listidu = 'usemedcine';
                    $.post(hosturl + "/patienttreatmentajax/getthisserach", {listid: listidu, searchtxt: searchtxt}, function (data) {
                        $('#' + listidu).html(data);
                        //type
                        var listidf = 'frommedcine';
                        $.post(hosturl + "/patienttreatmentajax/getthisserach", {listid: listidf, searchtxt: searchtxt}, function (data) {
                            $('#' + listidf).html(data);
                        });
                    });

                });

            });



        };

        function restoreRow(oTable, nRow) {
            var aData = oTable.fnGetData(nRow);
            var jqTds = $('>td', nRow);
            for (var i = 0, iLen = jqTds.length; i < iLen; i++) {
                oTable.fnUpdate(aData[i], nRow, i, false);
            }

            oTable.fnDraw();
        }

        function editRow(oTable, nRow) {
            var aData = oTable.fnGetData(nRow);
            var jqTds = $('>td', nRow);
            jqTds[0].innerHTML = '<input type="text" list="idmedcine" class="form-control input-small testautocom getallwidth" value="' + aData[0] + '"> <datalist id="idmedcine"></datalist>';
            jqTds[1].innerHTML = '<input type="text" list="groupmedcine" class="form-control input-small testautocom getallwidth" value="' + aData[1] + '"> <datalist id="groupmedcine"></datalist>';
            jqTds[2].innerHTML = '<input type="text" list="namemedcine" class="form-control input-small testautocom getallwidth" value="' + aData[2] + '"> <datalist id="namemedcine"></datalist>';
            jqTds[3].innerHTML = '<input type="text" list="frommedcine" class="form-control input-small testautocom getallwidth" value="' + aData[3] + '"> <datalist id="frommedcine"></datalist>';
            jqTds[4].innerHTML = '<input type="text" list="usemedcine" class="form-control input-small testautocom getallwidth" value="' + aData[4] + '"> <datalist id="usemedcine"></datalist>';
            jqTds[5].innerHTML = '<a class="edit" href="">Save</a>';
            jqTds[6].innerHTML = '<a class="cancel" href="">Cancel</a>';
            jqTds[7].innerHTML = '';
        }

        function saveRow(oTable, nRow) {
            var jqInputs = $('input', nRow);
            oTable.fnUpdate(jqInputs[0].value, nRow, 0, false);
            oTable.fnUpdate(jqInputs[1].value, nRow, 1, false);
            oTable.fnUpdate(jqInputs[2].value, nRow, 2, false);
            oTable.fnUpdate(jqInputs[3].value, nRow, 3, false);
            oTable.fnUpdate(jqInputs[4].value, nRow, 4, false);
            oTable.fnUpdate('<a class="edit" href="">Edit</a>', nRow, 5, false);
            oTable.fnUpdate('<a class="duplicate" href="">Duplicate</a>', nRow, 6, false);
            oTable.fnUpdate('<a class="delete" href="">Delete</a>', nRow, 7, false);
            oTable.fnDraw();
        }

        function cancelEditRow(oTable, nRow) {
            var jqInputs = $('input', nRow);
            oTable.fnUpdate(jqInputs[0].value, nRow, 0, false);
            oTable.fnUpdate(jqInputs[1].value, nRow, 1, false);
            oTable.fnUpdate(jqInputs[2].value, nRow, 2, false);
            oTable.fnUpdate(jqInputs[3].value, nRow, 3, false);
            oTable.fnUpdate(jqInputs[4].value, nRow, 4, false);
            oTable.fnUpdate('<a class="edit" href="">Edit</a>', nRow, 5, false);
            oTable.fnDraw();
        }

        var table = $('#sample_editable_1');

        var oTable = table.dataTable({
            // Uncomment below line("dom" parameter) to fix the dropdown overflow issue in the datatable cells. The default datatable layout
            // setup uses scrollable div(table-scrollable) with overflow:auto to enable vertical scroll(see: assets/global/plugins/datatables/plugins/bootstrap/dataTables.bootstrap.js).
            // So when dropdowns used the scrollable div should be removed.
            //"dom": "<'row'<'col-md-6 col-sm-12'l><'col-md-6 col-sm-12'f>r>t<'row'<'col-md-5 col-sm-12'i><'col-md-7 col-sm-12'p>>",
            "ajax": '' + hosturl + '/drugsajax',
            "aoColumnDefs": [
                {"sClass": "hide_me", "aTargets": [0]}
                , {
                    'orderable': false,
                    "searchable": false,
                    "targets": [5]
                }, {
                    'orderable': false,
                    "searchable": false,
                    "targets": [6]
                }, {
                    'orderable': false,
                    "searchable": false,
                    "targets": [7]
                }
            ],
            "lengthMenu": [
                [50, 100, 150, -1],
                [50, 100, 150, "All"] // change per page values here
            ],
            // set the initial value
            "pageLength": 50,
            "language": {
                "lengthMenu": " _MENU_"
            },
            "columnDefs": [{// set default column settings
                    'orderable': true,
                    'targets': [0]
                }, {
                    "searchable": true,
                    "targets": [0]
                }],
            "order": [
                [2, "asc"]
            ] // set first column as a default sort by asc
        });
        var tableWrapper = $("#sample_editable_1_wrapper");
        tableWrapper.find(".dataTables_length select").select2({
            showSearchInput: false //hide search box with special css class
        }); // initialize select2 dropdown

        var nEditing = null;
        var nNew = false;
        $('#sample_editable_1_new').click(function (e) {
            e.preventDefault();
            getdata();
            if (nNew && nEditing) {
                if (confirm("Previose row not saved. Do you want to save it ?")) {
                    saveRow(oTable, nEditing); // save
                    $(nEditing).find("td:first").html("Untitled");
                    nEditing = null;
                    nNew = false;
                } else {
                    oTable.fnDeleteRow(nEditing); // cancel
                    nEditing = null;
                    nNew = false;
                    return;
                }
            }

            var aiNew = oTable.fnAddData(['', '', '', '', '', '', '', '']);
            var nRow = oTable.fnGetNodes(aiNew[0]);
            editRow(oTable, nRow);
            nEditing = nRow;
            nNew = true;
        });
        /*table.on('keypress', '.testautocom', function (e) {

         var listid = $(this).attr('list');
         var searchtxt = $(this).val();
         $.post(hosturl + "/patienttreatmentajax/getthisserach", {listid: listid, searchtxt: searchtxt}, function (data) {
         $('#' + listid).html(data);
         });

         });*/
        table.on('click', '.delete', function (e) {
            e.preventDefault();
            if (confirm("Are you sure to delete this row ?") == false) {
                return;
            }

            var nRow = $(this).parents('tr')[0];
            var aData = oTable.fnGetData(nRow);

            $drugid = aData[0];
            $.post(hosturl + '/patienttreatmentajax/deletedrug', {d_id: $drugid}, function ()
            {
                oTable.fnDeleteRow(nRow);
            });
            //alert("Deleted! Do not forget to do some ajax to sync with backend :)");
        });
        table.on('click', '.cancel', function (e) {
            e.preventDefault();
            if (nNew) {
                oTable.fnDeleteRow(nEditing);
                nEditing = null;
                nNew = false;
            } else {
                restoreRow(oTable, nEditing);
                nEditing = null;
            }
        });
        table.on('click', '.edit', function (e) {
            e.preventDefault();
            /* Get the row as a parent of the link that was clicked on */
            var nRow = $(this).parents('tr')[0];
            getdata();
            if (nEditing !== null && nEditing != nRow) {
                /* Currently editing - but not this row - restore the old before continuing to edit mode */

                restoreRow(oTable, nEditing);
                editRow(oTable, nRow);
                nEditing = nRow;
            } else if (nEditing == nRow && this.innerHTML == "Save") {
                /* Editing this row and want to save it */
                saveRow(oTable, nEditing);
                var aData = oTable.fnGetData(nRow);
                if (aData[0] === '') {
                    //alert("Insert! Do not forget to do some ajax to sync with backend :)");
                    $drugname = aData[2];
                    $drugcat = aData[1];
                    $drugdos = aData[4];
                    $druguse = aData[3];
                    $.post(hosturl + '/patienttreatmentajax/adddrug', {drugname: $drugname, drugtype: $druguse, drugcat: $drugcat, drugdos: $drugdos}, function (data)
                    {
                        //draw in return ajax
                        oTable.fnUpdate(Number(data), nRow, 0, false); //return id
                        oTable.fnUpdate(aData[1].value, nRow, 1, false);
                        oTable.fnUpdate(aData[2].value, nRow, 2, false);
                        oTable.fnUpdate(aData[3].value, nRow, 3, false);
                        oTable.fnUpdate(aData[4].value, nRow, 4, false);
                        oTable.fnUpdate('<a class="edit" href="">Edit</a>', nRow, 5, false);
                        oTable.fnUpdate('<a class="delete" href="">Delete</a>', nRow, 6, false);
                        oTable.fnUpdate('<a class="duplicate" href="">Duplicate</a>', nRow, 7, false);
                        oTable.fnDraw();
                    });


                } else {
                    //alert("Updated! Do not forget to do some ajax to sync with backend :)");
                    $drugname = aData[2];
                    $drugcat = aData[1];
                    $drugdos = aData[4];
                    $druguse = aData[3];
                    $drugid = aData[0];

                    $.post(hosturl + '/patienttreatmentajax/updatedrug', {drugname: $drugname, drugtype: $druguse, drugcat: $drugcat, drugdos: $drugdos, d_id: $drugid}, function (data)
                    {
                    });
                }
                nEditing = null;
            } else {
                /* No edit in progress - let's start one */
                editRow(oTable, nRow);
                nEditing = nRow;
            }
        });
        table.on('click', '.duplicate', function (e) {
            e.preventDefault();

            //alert('duplicate ajax');

            var nRow = $(this).parents('tr')[0];
            var aData = oTable.fnGetData(nRow);
            var aiNew = oTable.fnAddData(["" + aData[0] + "", "" + aData[1] + "", "" + aData[2] + "", "" + aData[3] + "", "" + aData[4] + "", "" + aData[5] + "", "" + aData[6] + "", "" + aData[7] + ""]);
            var nRow = oTable.fnGetNodes(aiNew[0]);
            $drugname = aData[2];
            $drugcat = aData[1];
            $drugdos = aData[4];
            $druguse = aData[3];
            $.post(hosturl + '/patienttreatmentajax/adddrug', {drugname: $drugname, drugtype: $druguse, drugcat: $drugcat, drugdos: $drugdos}, function (data)
            {
                oTable.fnUpdate(Number(data), nRow, 0, false); //new id
                oTable.fnUpdate(aData[1].value, nRow, 1, false);
                oTable.fnUpdate(aData[2].value, nRow, 2, false);
                oTable.fnUpdate(aData[3].value, nRow, 3, false);
                oTable.fnUpdate(aData[4].value, nRow, 4, false);
                oTable.fnUpdate('<a class="edit" href="">Edit</a>', nRow, 5, false);
                oTable.fnUpdate('<a class="delete" href="">Delete</a>', nRow, 6, false);
                oTable.fnUpdate('<a class="duplicate" href="">Duplicate</a>', nRow, 7, false);
                oTable.fnDraw();
                nEditing = nRow;
                nNew = true;

                editRow(oTable, nRow);
                nEditing = nRow;
            });



        });



    };
    return {
        //main function to initiate the module
        init: function () {
            handleTable();
        }

    };
}();